clear
close all

%---
% load image from disk
load image_bruit
whos J

figure
subplot(2,4,1), imshow(J), title('image test')

%---
% Prewitt
Ph=fspecial('prewitt');
Pv=-Ph';
JP=filter2(Pv,J);
subplot(2,4,2), imshow(JP(2:end-1,2:end-1)), title('Prewitt')

% seuillage
seuilP=.25;
JPs=JP(2:end-1,2:end-1)>seuilP;
% sauver l'image de contour seuille JPs
save img_Prewitt_seuil JPs
subplot(2,4,6), imshow(JPs), title('Prewitt+seuil')

%---
% Sobel
Sh=fspecial('sobel');
Sv=-Sh';
JS=filter2(Sv,J);
subplot(2,4,3), imshow(JS(2:end-1,2:end-1)), title('Sobel')

% seuillage
seuilS=.35;
JSs=JS(2:end-1,2:end-1)>seuilS;
subplot(2,4,7), imshow(JSs), title('Sobel+seuil')

%---
% Roberts
Ra=[1 0;0 -1];
Rb=rot90(Ra,-1);
JRa=filter2(Ra,J);
JRb=filter2(Rb,J);
JR=sqrt(JRa.*JRa+JRb.*JRb);
subplot(2,4,4), imshow(JR(2:end-1,2:end-1)), title('Roberts')

% seuillage
seuilR=.165;
JRs=JR(2:end-1,2:end-1)>seuilR;
subplot(2,4,8), imshow(JRs), title('Roberts+seuil')

%---
% mise en vidence du contour
sumP=sum(JPs);
sumS=sum(JSs);
sumR=sum(JRs);

dim=128;

% dtections autour du contour
{'-------------------------' ;
 'Dtections de contours...' ;
 '-------------------------' ;
 ['Prewitt : ', int2str(sumP(dim/2-2:dim/2+1))] ;
 ['Sobel   : ', int2str(sumS(dim/2-2:dim/2+1))] ;
 ['Roberts : ', int2str(sumR(dim/2-2:dim/2+1))] ;
 '-------------------------' }

% => probabilits de dtection
{'-------------------------------' ;
 '=> Probabilits de dtection...' ;
 '-------------------------------' ;
 ['Prewitt : ', num2str(sum(sumP(dim/2-1:dim/2))/(2*(dim-2)))] ;
 ['Sobel   : ', num2str(sum(sumS(dim/2-1:dim/2))/(2*(dim-2)))] ;
 ['Roberts : ', num2str(sum(sumR(dim/2-1))/(dim-2))] ;
 '-------------------------------' }

% fausses alarmes
{'------------------' ;
 'Fausses alarmes...' ;
 '------------------' ;
 ['Prewitt : ', num2str(sum(sumP(1:dim/2-2))+sum(sumP(dim/2+1:end)))] ;
 ['Sobel   : ', num2str(sum(sumS(1:dim/2-2))+sum(sumS(dim/2+1:end)))] ;
 ['Roberts : ', num2str(sum(sumR(1:dim/2-2))+sum(sumR(dim/2:end)))] ;
 '------------------' }

% => probabilits de fausse alarme
{'-----------------------------------' ;
 '=> Probabilits de fausse alarme...' ;
 '-----------------------------------' ;
 ['Prewitt : ', num2str((sum(sumP(1:dim/2-2))+sum(sumP(dim/2+1:end)))/(dim-2)^2)] ;
 ['Sobel   : ', num2str((sum(sumS(1:dim/2-2))+sum(sumS(dim/2+1:end)))/(dim-2)^2)] ;
 ['Roberts : ', num2str((sum(sumR(1:dim/2-2))+sum(sumR(dim/2:end)))/(dim-1)^2)] ;
 '-----------------------------------' }